searchNodes=[{"doc":"PostgreSQL driver for Elixir.Postgrex is a partial implementation of the Postgres frontend/backend message protocol. It performs wire messaging in Elixir, as opposed to binding to a library such as libpq in C.A Postgrex query is performed as &quot;extended query&quot;. An &quot;extended query&quot; involves separate server-side parse, bind, and execute stages, each of which may be re-used for efficiency. For example, libraries like Ecto caches queries, so a query only has to be parsed and planned once. This is all done via wire messaging, without relying on PREPARE q AS (...) and EXECUTE q() SQL statements directly.This module handles the connection to PostgreSQL, providing support for queries, transactions, connection backoff, logging, pooling and more.Note that the notifications API (pub/sub) supported by PostgreSQL is handled by Postgrex.Notifications. Hence, to use this feature, you need to start a separate (notifications) connection.","ref":"Postgrex.html","title":"Postgrex","type":"module"},{"doc":"Returns a supervisor child specification for a DBConnection pool.","ref":"Postgrex.html#child_spec/1","title":"Postgrex.child_spec/1","type":"function"},{"doc":"Closes an (extended) prepared query and returns :ok or {:error, %Postgrex.Error{}} if there was an error. Closing a query releases any resources held by postgresql for a prepared query with that name. See Postgrex.Query for the query data.This function may still raise an exception if there is an issue with types (ArgumentError), connection (DBConnection.ConnectionError), ownership (DBConnection.OwnershipError) or other error (RuntimeError).Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Close request timeout (default: 15000);:mode - set to :savepoint to use a savepoint to rollback to before the close on error, otherwise set to :transaction (default: :transaction);Examplesquery = Postgrex.prepare!(conn, &quot;&quot;, &quot;CREATE TABLE posts (id serial, title text)&quot;) Postgrex.close(conn, query)","ref":"Postgrex.html#close/3","title":"Postgrex.close/3","type":"function"},{"doc":"Closes an (extended) prepared query and returns :ok or raises Postgrex.Error if there was an error. See close/3.","ref":"Postgrex.html#close!/3","title":"Postgrex.close!/3","type":"function"},{"doc":"Runs an (extended) prepared query.It returns the result as {:ok, %Postgrex.Query{}, %Postgrex.Result{}} or {:error, %Postgrex.Error{}} if there was an error. Parameters are given as part of the prepared query, %Postgrex.Query{}.See the README for information on how Postgrex encodes and decodes Elixir values by default. See Postgrex.Query for the query data and Postgrex.Result for the result data.Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Execute request timeout (default: 15000);:decode_mapper - Fun to map each row in the result to a term after decoding, (default: fn x -&gt; x end);:mode - set to :savepoint to use a savepoint to rollback to before the execute on error, otherwise set to :transaction (default: :transaction);Examplesquery = Postgrex.prepare!(conn, &quot;&quot;, &quot;CREATE TABLE posts (id serial, title text)&quot;) Postgrex.execute(conn, query, []) query = Postgrex.prepare!(conn, &quot;&quot;, &quot;SELECT id FROM posts WHERE title like $1&quot;) Postgrex.execute(conn, query, [&quot;%my%&quot;])","ref":"Postgrex.html#execute/4","title":"Postgrex.execute/4","type":"function"},{"doc":"Runs an (extended) prepared query and returns the result or raises Postgrex.Error if there was an error. See execute/4.","ref":"Postgrex.html#execute!/4","title":"Postgrex.execute!/4","type":"function"},{"doc":"Returns a cached map of connection parameters.Options:timeout - Call timeout (default: 15000)","ref":"Postgrex.html#parameters/2","title":"Postgrex.parameters/2","type":"function"},{"doc":"Prepares an (extended) query and returns the result as {:ok, %Postgrex.Query{}} or {:error, %Postgrex.Error{}} if there was an error. Parameters can be set in the query as $1 embedded in the query string. To execute the query call execute/4. To close the prepared query call close/3. See Postgrex.Query for the query data.This function may still raise an exception if there is an issue with types (ArgumentError), connection (DBConnection.ConnectionError), ownership (DBConnection.OwnershipError) or other error (RuntimeError).Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Prepare request timeout (default: 15000);:mode - set to :savepoint to use a savepoint to rollback to before the prepare on error, otherwise set to :transaction (default: :transaction);ExamplesPostgrex.prepare(conn, &quot;&quot;, &quot;CREATE TABLE posts (id serial, title text)&quot;)","ref":"Postgrex.html#prepare/4","title":"Postgrex.prepare/4","type":"function"},{"doc":"Prepares an (extended) query and returns the prepared query or raises Postgrex.Error if there was an error. See prepare/4.","ref":"Postgrex.html#prepare!/4","title":"Postgrex.prepare!/4","type":"function"},{"doc":"Prepares and executes a query in a single step.It returns the result as {:ok, %Postgrex.Query{}, %Postgrex.Result{}} or {:error, %Postgrex.Error{}} if there was an error. Parameters are given as part of the prepared query, %Postgrex.Query{}.See the README for information on how Postgrex encodes and decodes Elixir values by default. See Postgrex.Query for the query data and Postgrex.Result for the result data.Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Execute request timeout (default: 15000);:decode_mapper - Fun to map each row in the result to a term after decoding, (default: fn x -&gt; x end);:mode - set to :savepoint to use a savepoint to rollback to before the execute on error, otherwise set to :transaction (default: :transaction);ExamplesPostgrex.prepare_execute(conn, &quot;&quot;, &quot;SELECT id FROM posts WHERE title like $1&quot;, [&quot;%my%&quot;])","ref":"Postgrex.html#prepare_execute/5","title":"Postgrex.prepare_execute/5","type":"function"},{"doc":"Prepares and runs a query and returns the result or raises Postgrex.Error if there was an error. See prepare_execute/5.","ref":"Postgrex.html#prepare_execute!/5","title":"Postgrex.prepare_execute!/5","type":"function"},{"doc":"Runs an (extended) query and returns the result as {:ok, %Postgrex.Result{}} or {:error, %Postgrex.Error{}} if there was a database error. Parameters can be set in the query as $1 embedded in the query string. Parameters are given as a list of elixir values. See the README for information on how Postgrex encodes and decodes Elixir values by default. See Postgrex.Result for the result data.This function may still raise an exception if there is an issue with types (ArgumentError), connection (DBConnection.ConnectionError), ownership (DBConnection.OwnershipError) or other error (RuntimeError).Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Query request timeout (default: 15000);:decode_mapper - Fun to map each row in the result to a term after decoding, (default: fn x -&gt; x end);:mode - set to :savepoint to use a savepoint to rollback to before the query on error, otherwise set to :transaction (default: :transaction);:cache_statement - Caches the query with the given nameExamplesPostgrex.query(conn, &quot;CREATE TABLE posts (id serial, title text)&quot;, []) Postgrex.query(conn, &quot;INSERT INTO posts (title) VALUES (&#39;my title&#39;)&quot;, []) Postgrex.query(conn, &quot;SELECT title FROM posts&quot;, []) Postgrex.query(conn, &quot;SELECT id FROM posts WHERE title like $1&quot;, [&quot;%my%&quot;]) Postgrex.query(conn, &quot;COPY posts TO STDOUT&quot;, [])","ref":"Postgrex.html#query/4","title":"Postgrex.query/4","type":"function"},{"doc":"Runs an (extended) query and returns the result or raises Postgrex.Error if there was an error. See query/3.","ref":"Postgrex.html#query!/4","title":"Postgrex.query!/4","type":"function"},{"doc":"Rollback a transaction, does not return.Aborts the current transaction fun. If inside multiple transaction/3 functions, bubbles up to the top level.Example{:error, :oops} = Postgrex.transaction(pid, fn(conn) -&gt; DBConnection.rollback(conn, :bar) IO.puts &quot;never reaches here!&quot; end)","ref":"Postgrex.html#rollback/2","title":"Postgrex.rollback/2","type":"function"},{"doc":"Start the connection process and connect to postgres.Options:hostname - Server hostname (default: PGHOST env variable, then localhost);:socket_dir - Connect to PostgreSQL via UNIX sockets in the given directory; The socket name is derived based on the port. This is the preferred method for configuring sockets and it takes precedence over the hostname. If you are connecting to a socket outside of the PostgreSQL convention, use :socket instead;:socket - Connect to PostgreSQL via UNIX sockets in the given path. This option takes precedence over the :hostname and :socket_dir;:port - Server port (default: PGPORT env variable, then 5432);:database - Database (default: PGDATABASE env variable; otherwise required);:username - Username (default: PGUSER env variable, then USER env var);:password - User password (default: PGPASSWORD env variable);:parameters - Keyword list of connection parameters;:timeout - Socket receive timeout when idle in milliseconds (default: 15000);:connect_timeout - Socket connect timeout in milliseconds (defaults to :timeout value);:handshake_timeout - Connection handshake timeout in milliseconds (defaults to :timeout value);:ssl - Set to true if ssl should be used (default: false);:ssl_opts - A list of ssl options, see the tls_client_option from the ssl docs;:socket_options - Options to be given to the underlying socket (applies to both TCP and UNIX sockets);:prepare - How to prepare queries, either :named to use named queries or :unnamed to force unnamed queries (default: :named);:transactions - Set to :strict to error on unexpected transaction state, otherwise set to :naive (default: :strict);:pool - The pool module to use, defaults to DBConnection.ConnectionPool. See the pool documentation for more options. The default :pool_size for the default pool is 1. If you set a different pool, this option must be included with all requests contacting the pool;:types - The types module to use, see Postgrex.TypeModule, this option is only required when using custom encoding or decoding (default: Postgrex.DefaultTypes);:disconnect_on_error_codes - List of error code atoms that when encountered will disconnect the connection. This is useful when using Postgrex against systems that support failover, which when it occurs will emit certain error codes e.g. :read_only_sql_transaction (default: []);:show_sensitive_data_on_connection_error - By default, Postgrex hides all information during connection errors to avoid leaking credentials or other sensitive information. You can set this option if you wish to see complete errors and stacktraces during connection errors:idle_interval - Ping connections after a period of inactivity in milliseconds. Defaults to 1000ms.Postgrex uses the DBConnection library and supports all DBConnection options like :idle, :after_connect etc. See DBConnection.start_link/2 for more information.Examplesiex&gt; {:ok, pid} = Postgrex.start_link(database: &quot;postgres&quot;) {:ok, #PID&lt;0.69.0&gt;}Run a query after connection has been established:iex&gt; {:ok, pid} = Postgrex.start_link(after_connect: &amp;Postgrex.query!(&amp;1, &quot;SET TIME ZONE &#39;UTC&#39;;&quot;, [])) {:ok, #PID&lt;0.69.0&gt;}Connect to postgres instance through a unix domain socketiex&gt; {:ok, pid} = Postgrex.start_link(socket_dir: &quot;/tmp&quot;, database: &quot;postgres&quot;) {:ok, #PID&lt;0.69.0&gt;}PgBouncerWhen using PgBouncer with transaction or statement pooling named prepared queries can not be used because the bouncer may route requests from the same postgrex connection to different PostgreSQL backend processes and discards named queries after the transactions closes. To force unnamed prepared queries set the :prepare option to :unnamed.Handling failoverSome services, such as AWS Aurora, support failovers. This means the database you are currently connected to may suddenly become read-only, and an attempt to do any write operation, such as INSERT/UPDATE/DELETE will lead to errors such as:11:11:03.089 [error] Postgrex.Protocol (#PID&lt;0.189.0&gt;) disconnected: ** (Postgrex.Error) ERROR 25006 (read_only_sql_transaction) cannot execute INSERT in a read-only transactionLuckily, you can instruct Postgrex to disconnect in such cases by using the following configuration:disconnect_on_error_codes: [:read_only_sql_transaction]This cause the connection process to attempt to reconnect according to the backoff configuration.","ref":"Postgrex.html#start_link/1","title":"Postgrex.start_link/1","type":"function"},{"doc":"Returns a stream for a query on a connection.Stream consumes memory in chunks of at most max_rows rows (see Options). This is useful for processing large datasets.A stream must be wrapped in a transaction and may be used as an Enumerable or a Collectable.When used as an Enumerable with a COPY .. TO STDOUT SQL query no other queries or streams can be interspersed until the copy has finished. Otherwise it is possible to intersperse enumerable streams and queries.When used as a Collectable the values are passed as copy data with the query. No other queries or streams can be interspersed until the copy has finished. If the query is not copying to the database the copy data will still be sent but is silently discarded.Options:max_rows - Maximum numbers of rows in a result (default to 500):decode_mapper - Fun to map each row in the result to a term after decoding, (default: fn x -&gt; x end);:mode - set to :savepoint to use a savepoint to rollback to before an execute on error, otherwise set to :transaction (default: :transaction);ExamplesPostgrex.transaction(pid, fn(conn) -&gt; query = Postgrex.prepare!(conn, &quot;&quot;, &quot;COPY posts TO STDOUT&quot;) stream = Postgrex.stream(conn, query, []) result_to_iodata = fn(%Postgrex.Result{rows: rows}) -&gt; rows end Enum.into(stream, File.stream!(&quot;posts&quot;), result_to_iodata) end) Postgrex.transaction(pid, fn(conn) -&gt; stream = Postgrex.stream(conn, &quot;COPY posts FROM STDIN&quot;, []) Enum.into(File.stream!(&quot;posts&quot;), stream) end)","ref":"Postgrex.html#stream/4","title":"Postgrex.stream/4","type":"function"},{"doc":"Acquire a lock on a connection and run a series of requests inside a transaction. The result of the transaction fun is return inside an :ok tuple: {:ok, result}.To use the locked connection call the request with the connection reference passed as the single argument to the fun. If the connection disconnects all future calls using that connection reference will fail.rollback/2 rolls back the transaction and causes the function to return {:error, reason}.transaction/3 can be nested multiple times if the connection reference is used to start a nested transaction. The top level transaction function is the actual transaction.Options:queue - Whether to wait for connection in a queue (default: true);:timeout - Transaction timeout (default: 15000);:mode - Set to :savepoint to use savepoints instead of an SQL transaction, otherwise set to :transaction (default: :transaction);The :timeout is for the duration of the transaction and all nested transactions and requests. This timeout overrides timeouts set by internal transactions and requests. The :mode will be used for all requests inside the transaction function.Example{:ok, res} = Postgrex.transaction(pid, fn(conn) -&gt; Postgrex.query!(conn, &quot;SELECT title FROM posts&quot;, []) end)","ref":"Postgrex.html#transaction/3","title":"Postgrex.transaction/3","type":"function"},{"doc":"A connection process name, pid or reference.A connection reference is used when making multiple requests to the same connection, see transaction/3.","ref":"Postgrex.html#t:conn/0","title":"Postgrex.conn/0","type":"type"},{"doc":"","ref":"Postgrex.html#t:execute_option/0","title":"Postgrex.execute_option/0","type":"type"},{"doc":"","ref":"Postgrex.html#t:option/0","title":"Postgrex.option/0","type":"type"},{"doc":"","ref":"Postgrex.html#t:start_option/0","title":"Postgrex.start_option/0","type":"type"},{"doc":"API for notifications (pub/sub) in PostgreSQL.In order to use it, first you need to start the notification process. In your supervision tree:{Postgrex.Notifications, name: MyApp.Notifications}Then you can listen to certain channels:{:ok, listen_ref} = Postgrex.Notifications.listen(MyApp.Notifications, &quot;channel&quot;)Now every time a message is broadcast on said channel, for example via PostgreSQL command line:NOTIFY &quot;channel&quot;, &quot;Oh hai!&quot;;You will receive a message in the format:{:notification, notification_pid, listen_ref, channel, message}Async connect and auto-reconnectsBy default, the notification system establishes a connection to the database on initialization, you can configure the connection to happen asynchronously. You can also configure the connection to automatically reconnect.Note however that when the notification system is waiting for a connection, any notifications that occur during the disconnection period are not queued and cannot be recovered. Similarly, any listen command will be queued until the connection is up.A note on casingWhile PostgreSQL seems to behave as case-insensitive, it actually has a very perculiar behaviour on casing. When you write:SELECT * FROM POSTSPostgreSQL actually converts POSTS into the lowercase posts. That's why both SELECT * FROM POSTS and SELECT * FROM posts feel equivalent. However, if you wrap the table name in quotes, then the casing in quotes will be preserved.These same rules apply to PostgreSQL notification channels. More importantly, whenever Postgrex.Notifications listens to a channel, it wraps the channel name in quotes. Therefore, if you listen to a channel named &quot;fooBar&quot; and you send a notification without quotes in the channel name, such as:NOTIFY fooBar, &quot;Oh hai!&quot;;The notification will not be received by Postgrex.Notifications because the notification will be effectively sent to &quot;foobar&quot; and not &quot;fooBar&quot;. Therefore, you must guarantee one of the two following properties:If you can wrap the channel name in quotes when sending a notification, then make sure the channel name has the exact same casing when listening and sending notificationsIf you cannot wrap the channel name in quotes when sending a notification, then make sure to give the lowercased channel name when listening","ref":"Postgrex.Notifications.html","title":"Postgrex.Notifications","type":"module"},{"doc":"Listens to an asynchronous notification channel using the LISTEN command.A message {:notification, connection_pid, ref, channel, payload} will be sent to the calling process when a notification is received.It returns {:ok, reference}. It may also return {:eventually, reference} if the notification process is not currently connected to the database and it was started with :sync_connect set to false or :auto_reconnect set to true. The reference can be used to issue an unlisten/3 command.Options:timeout - Call timeout (default: 5000)","ref":"Postgrex.Notifications.html#listen/3","title":"Postgrex.Notifications.listen/3","type":"function"},{"doc":"Listens to an asynchronous notification channel channel. See listen/2.","ref":"Postgrex.Notifications.html#listen!/3","title":"Postgrex.Notifications.listen!/3","type":"function"},{"doc":"Start the notification connection process and connect to postgres.The options that this function accepts are the same as those accepted by Postgrex.start_link/1, as well as the extra options :sync_connect, :auto_reconnect, :reconnect_backoff, and :configure.Options:sync_connect - controls if the connection should be established on boot or asynchronously right after boot. Defaults to true.:auto_reconnect - automatically attempt to reconnect to the database in event of a disconnection. See the note about async connect and auto-reconnects above. Defaults to false.:reconnect_backoff - time (in ms) between reconnection attempts when auto_reconnect is enabled. Defaults to 500.:idle_interval - while also accepted on Postgrex.start_link/1, it has a default of 5000ms in Postgrex.Notifications (instead of 1000ms).:configure - A function to run before every connect attempt to dynamically configure the options as a {module, function, args}, where the current options will prepended to args. Defaults to nil.","ref":"Postgrex.Notifications.html#start_link/1","title":"Postgrex.Notifications.start_link/1","type":"function"},{"doc":"Stops listening on the given channel by passing the reference returned from listen/2.Options:timeout - Call timeout (default: 5000)","ref":"Postgrex.Notifications.html#unlisten/3","title":"Postgrex.Notifications.unlisten/3","type":"function"},{"doc":"Stops listening on the given channel by passing the reference returned from listen/2.","ref":"Postgrex.Notifications.html#unlisten!/3","title":"Postgrex.Notifications.unlisten!/3","type":"function"},{"doc":"","ref":"Postgrex.Notifications.html#t:server/0","title":"Postgrex.Notifications.server/0","type":"type"},{"doc":"Query struct returned from a successfully prepared query.Its public fields are:name - The name of the prepared statement;statement - The prepared statement;columns - The column names;ref - A reference used to identify prepared queries;Prepared queriesOnce a query is prepared with Postgrex.prepare/4, the returned query will have its ref field set to a reference. When Postgrex.execute/4 is called with the prepared query, it always returns a query. If the ref field in the query given to execute and the one returned are the same, it means the cached prepared query was used. If the ref field is not the same, it means the query had to be re-prepared.","ref":"Postgrex.Query.html","title":"Postgrex.Query","type":"module"},{"doc":"","ref":"Postgrex.Query.html#t:t/0","title":"Postgrex.Query.t/0","type":"type"},{"doc":"Result struct returned from any successful query. Its fields are:command - An atom of the query command, for example: :select or :insert;columns - The column names;rows - The result set. A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column;num_rows - The number of fetched or affected rows;connection_id - The OS pid of the PostgreSQL backend that executed the query;messages - A list of maps of messages, such as hints and notices, sent by the the driver during the execution of the query","ref":"Postgrex.Result.html","title":"Postgrex.Result","type":"module"},{"doc":"","ref":"Postgrex.Result.html#t:t/0","title":"Postgrex.Result.t/0","type":"type"},{"doc":"Struct for PostgreSQL box.Fieldsupper_rightbottom_left","ref":"Postgrex.Box.html","title":"Postgrex.Box","type":"module"},{"doc":"","ref":"Postgrex.Box.html#t:t/0","title":"Postgrex.Box.t/0","type":"type"},{"doc":"Struct for PostgreSQL circle.Fieldscenterradius","ref":"Postgrex.Circle.html","title":"Postgrex.Circle","type":"module"},{"doc":"","ref":"Postgrex.Circle.html#t:t/0","title":"Postgrex.Circle.t/0","type":"type"},{"doc":"Struct for PostgreSQL inet / cidr.Fieldsaddressnetmask","ref":"Postgrex.INET.html","title":"Postgrex.INET","type":"module"},{"doc":"","ref":"Postgrex.INET.html#t:t/0","title":"Postgrex.INET.t/0","type":"type"},{"doc":"Struct for PostgreSQL interval.Fieldsmonthsdayssecsmicrosecs","ref":"Postgrex.Interval.html","title":"Postgrex.Interval","type":"module"},{"doc":"","ref":"Postgrex.Interval.html#compare/2","title":"Postgrex.Interval.compare/2","type":"function"},{"doc":"","ref":"Postgrex.Interval.html#to_string/1","title":"Postgrex.Interval.to_string/1","type":"function"},{"doc":"","ref":"Postgrex.Interval.html#t:t/0","title":"Postgrex.Interval.t/0","type":"type"},{"doc":"Struct for PostgreSQL lexeme.Fieldswordpositions","ref":"Postgrex.Lexeme.html","title":"Postgrex.Lexeme","type":"module"},{"doc":"","ref":"Postgrex.Lexeme.html#t:t/0","title":"Postgrex.Lexeme.t/0","type":"type"},{"doc":"Struct for PostgreSQL line.Note, lines are stored in PostgreSQL in the form {a, b, c}, which parameterizes a line as a*x + b*y + c = 0.Fieldsabc","ref":"Postgrex.Line.html","title":"Postgrex.Line","type":"module"},{"doc":"","ref":"Postgrex.Line.html#t:t/0","title":"Postgrex.Line.t/0","type":"type"},{"doc":"Struct for PostgreSQL lseg.Fieldspoint1point2","ref":"Postgrex.LineSegment.html","title":"Postgrex.LineSegment","type":"module"},{"doc":"","ref":"Postgrex.LineSegment.html#t:t/0","title":"Postgrex.LineSegment.t/0","type":"type"},{"doc":"Struct for PostgreSQL macaddr.Fieldsaddress","ref":"Postgrex.MACADDR.html","title":"Postgrex.MACADDR","type":"module"},{"doc":"","ref":"Postgrex.MACADDR.html#t:macaddr/0","title":"Postgrex.MACADDR.macaddr/0","type":"type"},{"doc":"","ref":"Postgrex.MACADDR.html#t:t/0","title":"Postgrex.MACADDR.t/0","type":"type"},{"doc":"Struct for PostgreSQL path.Fieldsopenpoints","ref":"Postgrex.Path.html","title":"Postgrex.Path","type":"module"},{"doc":"","ref":"Postgrex.Path.html#t:t/0","title":"Postgrex.Path.t/0","type":"type"},{"doc":"Struct for PostgreSQL point.Fieldsxy","ref":"Postgrex.Point.html","title":"Postgrex.Point","type":"module"},{"doc":"","ref":"Postgrex.Point.html#t:t/0","title":"Postgrex.Point.t/0","type":"type"},{"doc":"Struct for PostgreSQL polygon.Fieldsvertices","ref":"Postgrex.Polygon.html","title":"Postgrex.Polygon","type":"module"},{"doc":"","ref":"Postgrex.Polygon.html#t:t/0","title":"Postgrex.Polygon.t/0","type":"type"},{"doc":"Struct for PostgreSQL range.Fieldslowerupperlower_inclusiveupper_inclusive","ref":"Postgrex.Range.html","title":"Postgrex.Range","type":"module"},{"doc":"","ref":"Postgrex.Range.html#t:t/0","title":"Postgrex.Range.t/0","type":"type"},{"doc":"An extension knows how to encode and decode PostgreSQL types to and from Elixir values.Custom extensions can be enabled via Postgrex.Types.define/3. Postgrex.Types.define/3 must be called on its own file, outside of any module and function, as it only needs to be defined once during compilation.For example to support label trees using the text encoding format:defmodule MyApp.LTree do @behaviour Postgrex.Extension # It can be memory efficient to copy the decoded binary because a # reference counted binary that points to a larger binary will be passed # to the decode/4 callback. Copying the binary can allow the larger # binary to be garbage collected sooner if the copy is going to be kept # for a longer period of time. See `:binary.copy/1` for more # information. def init(opts) do Keyword.get(opts, :decode_copy, :copy) end # Use this extension when `type` from %Postgrex.TypeInfo{} is &quot;ltree&quot; def matching(_state), do: [type: &quot;ltree&quot;] # Use the text format, &quot;ltree&quot; does not have a binary format. def format(_state), do: :text # Use quoted expression to encode a string that is the same as # postgresql&#39;s ltree text format. The quoted expression should contain # clauses that match those of a `case` or `fn`. Encoding matches on the # value and returns encoded `iodata()`. The first 4 bytes in the # `iodata()` must be the byte size of the rest of the encoded data, as a # signed 32bit big endian integer. def encode(_state) do quote do bin when is_binary(bin) -&gt; [&lt;&lt;byte_size(bin) :: signed-size(32)&gt;&gt; | bin] end end # Use quoted expression to decode the data to a string. Decoding matches # on an encoded binary with the same signed 32bit big endian integer # length header. def decode(:reference) do quote do &lt;&lt;len::signed-size(32), bin::binary-size(len)&gt;&gt; -&gt; bin end end def decode(:copy) do quote do &lt;&lt;len::signed-size(32), bin::binary-size(len)&gt;&gt; -&gt; :binary.copy(bin) end end endThis example could be used in a custom types module:Postgrex.Types.define(MyApp.Types, [MyApp.LTree])Or pass in opts for the extension that will be passed to the init/1 callback:Postgrex.Types.define(MyApp.Types, [{MyApp.LTree, [decode_copy: :copy]}])","ref":"Postgrex.Extension.html","title":"Postgrex.Extension","type":"behaviour"},{"doc":"Returns a quoted list of clauses that decode a binary to an Elixir value.The pattern must use binary syntax and decode a fixed length using the signed 32 bit big endian integer byte length header.def decode(_) do quote do # length header is in bytes &lt;&lt;len :: signed-32, integer :: signed-size(len)-unit(8)&gt;&gt; -&gt; integer end end","ref":"Postgrex.Extension.html#c:decode/1","title":"Postgrex.Extension.decode/1","type":"callback"},{"doc":"Returns a quoted list of clauses that encode an Elixir value to iodata.It must use a signed 32 bit big endian integer byte length header.def encode(_) do quote do integer -&gt; &lt;&lt;8 :: signed-32, integer :: signed-64&gt;&gt; end end","ref":"Postgrex.Extension.html#c:encode/1","title":"Postgrex.Extension.encode/1","type":"callback"},{"doc":"Returns the format the type should be encoded as. See http://www.postgresql.org/docs/9.4/static/protocol-overview.html#PROTOCOL-FORMAT-CODES.","ref":"Postgrex.Extension.html#c:format/1","title":"Postgrex.Extension.format/1","type":"callback"},{"doc":"Should perform any initialization of the extension. The function receives the user options. The state returned from this function will be passed to other callbacks.","ref":"Postgrex.Extension.html#c:init/1","title":"Postgrex.Extension.init/1","type":"callback"},{"doc":"Specifies the types the extension matches, see Postgrex.TypeInfo for specification of the fields.","ref":"Postgrex.Extension.html#c:matching/1","title":"Postgrex.Extension.matching/1","type":"callback"},{"doc":"","ref":"Postgrex.Extension.html#t:state/0","title":"Postgrex.Extension.state/0","type":"type"},{"doc":"","ref":"Postgrex.Extension.html#t:t/0","title":"Postgrex.Extension.t/0","type":"type"},{"doc":"The information about a type that is provided to the custom encoder/decoder functions. See http://www.postgresql.org/docs/9.4/static/catalog-pg-type.html for clarifications of the fields.oid - The type's id;type - The type name;send - The name of the &quot;send&quot; function (the function postgres uses to convert the type to its binary format);receive - The name of the &quot;receive&quot; function (the function postgres uses to convert the type from its binary format);output - The name of the &quot;output&quot; function (the function postgres uses to convert the type to its text format);input - The name of the &quot;input&quot; function (the function postgres uses to convert the type from its text format);array_elem - If this is an array, the array elements' oid;base_type - If this is a range type, the base type's oid;comp_elems - If this is a composite type (record), the tuple elements' oid;","ref":"Postgrex.TypeInfo.html","title":"Postgrex.TypeInfo","type":"module"},{"doc":"","ref":"Postgrex.TypeInfo.html#t:t/0","title":"Postgrex.TypeInfo.t/0","type":"type"},{"doc":"Encodes and decodes between PostgreSQL protocol and Elixir values.","ref":"Postgrex.Types.html","title":"Postgrex.Types","type":"module"},{"doc":"Defines a type module with custom extensions and options.Postgrex.Types.define/3 must be called on its own file, outside of any module and function, as it only needs to be defined once during compilation.Type modules are given to Postgrex on start_link via the :types option and are used to control how Postgrex encodes and decodes data coming from Postgrex.For example, to define a new type module with a custom extension called MyExtension while also changing Postgrex's default behaviour regarding binary decoding, you may create a new file called &quot;lib/my_app/postgrex_types.ex&quot; with the following:Postgrex.Types.define(MyApp.PostgrexTypes, [MyExtension], [decode_binary: :reference])The line above will define a new module, called MyApp.PostgrexTypes which can be passed as :types when starting Postgrex. The type module works by rewriting and inlining the extensions' encode and decode expressions in an optimal fashion for postgrex to encode parameters and decode multiple rows at a time.ExtensionsExtensions is a list of Postgrex.Extension modules or a 2-tuple containing the module and a keyword list. The keyword, defaulting to [], will be passed to the modules init/1 callback.Extensions at the front of the list will take priority over later extensions when the matching/1 callback returns have conflicting matches. If an extension is not provided for a type then Postgrex will fallback to default encoding/decoding methods where possible. All extensions that ship as part of Postgrex are included out of the box.See Postgrex.Extension for more information on extensions.Options:null - The atom to use as a stand in for postgres' NULL in encoding and decoding. The module attribute @null is registered with the value so that extension can access the value if desired (default: nil);:decode_binary - Either :copy to copy binary values when decoding with default extensions that return binaries or :reference to use a reference counted binary of the binary received from the socket. Referencing a potentially larger binary can be more efficient if the binary value is going to be garbaged collected soon because a copy is avoided. However the larger binary can not be garbage collected until all references are garbage collected (default: :copy);:json - The JSON module to encode and decode JSON binaries, calls module.encode_to_iodata!/1 to encode and module.decode!/1 to decode. If nil then no default JSON handling (default: Application.get_env(:postgrex, :json_library, Jason));:bin_opt_info - Either true to enable binary optimisation information, or false to disable, for more information see Kernel.SpecialForms.&lt;&lt;&gt;&gt;/1 in Elixir (default: false);:debug_defaults - Generate debug information when building default extensions so they point to the proper source. Enabling such option will increase the time to compile the type module (default: false);","ref":"Postgrex.Types.html#define/3","title":"Postgrex.Types.define/3","type":"function"},{"doc":"PostgreSQL internal identifier that maps to a type. See http://www.postgresql.org/docs/9.4/static/datatype-oid.html.","ref":"Postgrex.Types.html#t:oid/0","title":"Postgrex.Types.oid/0","type":"type"},{"doc":"State used by the encoder/decoder functions","ref":"Postgrex.Types.html#t:state/0","title":"Postgrex.Types.state/0","type":"opaque"},{"doc":"Term used to describe type information","ref":"Postgrex.Types.html#t:type/0","title":"Postgrex.Types.type/0","type":"opaque"},{"doc":"","ref":"Postgrex.Error.html","title":"Postgrex.Error","type":"exception"},{"doc":"","ref":"Postgrex.Error.html#t:t/0","title":"Postgrex.Error.t/0","type":"type"},{"doc":"","ref":"Postgrex.QueryError.html","title":"Postgrex.QueryError","type":"exception"},{"doc":"PostgrexPostgreSQL driver for Elixir.Documentation: http://hexdocs.pm/postgrex/","ref":"readme.html","title":"Postgrex","type":"extras"},{"doc":"iex&gt; {:ok, pid} = Postgrex.start_link(hostname: &quot;localhost&quot;, username: &quot;postgres&quot;, password: &quot;postgres&quot;, database: &quot;postgres&quot;) {:ok, #PID&lt;0.69.0&gt;} iex&gt; Postgrex.query!(pid, &quot;SELECT user_id, text FROM comments&quot;, []) %Postgrex.Result{command: :select, empty?: false, columns: [&quot;user_id&quot;, &quot;text&quot;], rows: [[3,&quot;hey&quot;],[4,&quot;there&quot;]], size: 2}} iex&gt; Postgrex.query!(pid, &quot;INSERT INTO comments (user_id, text) VALUES (10, &#39;heya&#39;)&quot;, []) %Postgrex.Result{command: :insert, columns: nil, rows: nil, num_rows: 1}}","ref":"readme.html#examples","title":"Postgrex - Examples","type":"extras"},{"doc":"Automatic decoding and encoding of Elixir values to and from PostgreSQL's binary formatUser defined extensions for encoding and decoding any PostgreSQL typeSupports transactions, prepared queries and multiple pools via DBConnectionSupports PostgreSQL 8.4, 9.0-9.6, and later (hstore is not supported on 8.4)","ref":"readme.html#features","title":"Postgrex - Features","type":"extras"},{"doc":"PostgreSQL Elixir ---------- ------ NULL nil bool true | false char &quot;é&quot; int 42 float 42.0 text &quot;eric&quot; bytea &lt;&lt;42&gt;&gt; numeric #Decimal&lt;42.0&gt; * date %Date{year: 2013, month: 10, day: 12} time(tz) %Time{hour: 0, minute: 37, second: 14} ** timestamp %NaiveDateTime{year: 2013, month: 10, day: 12, hour: 0, minute: 37, second: 14} timestamptz %DateTime{year: 2013, month: 10, day: 12, hour: 0, minute: 37, second: 14, time_zone: &quot;Etc/UTC&quot;} ** interval %Postgrex.Interval{months: 14, days: 40, secs: 10920, microsecs: 315} array [1, 2, 3] composite type {42, &quot;title&quot;, &quot;content&quot;} range %Postgrex.Range{lower: 1, upper: 5} uuid &lt;&lt;160,238,188,153,156,11,78,248,187,109,107,185,189,56,10,17&gt;&gt; hstore %{&quot;foo&quot; =&gt; &quot;bar&quot;} oid types 42 enum &quot;ok&quot; *** bit &lt;&lt; 1::1, 0::1 &gt;&gt; varbit &lt;&lt; 1::1, 0::1 &gt;&gt; tsvector [%Postgrex.Lexeme{positions: [{1, :A}], word: &quot;a&quot;}]* Decimal** Timezones will always be normalized to UTC or assumed to be UTC when no information is available, either by PostgreSQL or Postgrex*** Enumerated types (enum) are custom named database types with strings as values.**** Anonymous composite types are decoded (read) as tuples but they cannot be encoded (written) to the databasePostgrex does not automatically cast between types. For example, you can't pass a string where a date is expected. To add type casting, support new types, or change how any of the types above are encoded/decoded, you can use extensions.","ref":"readme.html#data-representation","title":"Postgrex - Data representation","type":"extras"},{"doc":"Postgrex comes with JSON support out of the box via the Jason library. To use it, add :jason to your dependencies:{:jason, &quot;~&gt; 1.0&quot;}You can customize it to use another library via the :json_library configuration:config :postgrex, :json_library, SomeOtherLibOnce you change the value, you have to recompile Postgrex, which can be done by cleaning its current build:mix deps.clean postgrex --build","ref":"readme.html#json-support","title":"Postgrex - JSON support","type":"extras"},{"doc":"Extensions are used to extend Postgrex' built-in type encoding/decoding.The extensions directory in this project provides implementation for many Postgres' built-in data types. It is also a great example of how to implement your own extensions. For example, you can look at the Date extension as a starting point.Once you defined your extensions, you should build custom type modules, passing all of your extensions as arguments:Postgrex.Types.define(MyApp.PostgrexTypes, [MyApp.Postgis.Extensions], [])Postgrex.Types.define/3 must be called on its own file, outside of any module and function, as it only needs to be defined once during compilation.Once a type module is defined, you must specify it on start_link:Postgrex.start_link(types: MyApp.PostgrexTypes)","ref":"readme.html#extensions","title":"Postgrex - Extensions","type":"extras"},{"doc":"PostgreSQL's wire protocol supports encoding types either as text or as binary. Unlike most client libraries Postgrex uses the binary protocol, not the text protocol. This allows for efficient encoding of types (e.g. 4-byte integers are encoded as 4 bytes, not as a string of digits) and automatic support for arrays and composite types.Unfortunately the PostgreSQL binary protocol transports OID types as integers while the text protocol transports them as string of their name, if one exists, and otherwise as integer.This means you either need to supply oid types as integers or perform an explicit cast (which would be automatic when using the text protocol) in the query.# Fails since $1 is regclass not text. query(&quot;select nextval($1)&quot;, [&quot;some_sequence&quot;]) # Perform an explicit cast, this would happen automatically when using a # client library that uses the text protocol. query(&quot;select nextval($1::text::regclass)&quot;, [&quot;some_sequence&quot;]) # Determine the oid once and store it for later usage. This is the most # efficient way, since PostgreSQL only has to perform the lookup once. Client # libraries using the text protocol do not support this. %{rows: [{sequence_oid}]} = query(&quot;select $1::text::regclass&quot;, [&quot;some_sequence&quot;]) query(&quot;select nextval($1)&quot;, [sequence_oid])","ref":"readme.html#oid-type-encoding","title":"Postgrex - OID type encoding","type":"extras"},{"doc":"When using PgBouncer with transaction or statement pooling named prepared queries can not be used because the bouncer may route requests from the same postgrex connection to different PostgreSQL backend processes and discards named queries after the transactions closes. To force unnamed prepared queries:Postgrex.start_link(prepare: :unnamed)","ref":"readme.html#pgbouncer","title":"Postgrex - PgBouncer","type":"extras"},{"doc":"To contribute you need to compile Postgrex from source and test it:$ git clone https://github.com/elixir-ecto/postgrex.git $ cd postgrex $ mix testThe tests requires some modifications to your hba file. The path to it can be found by running $ psql -U postgres -c &quot;SHOW hba_file&quot; in your shell. Put the following above all other configurations (so that they override):local all all trust host all postgrex_md5_pw 127.0.0.1/32 md5 host all postgrex_cleartext_pw 127.0.0.1/32 password host all postgrex_scram_pw 127.0.0.1/32 scram-sha-256The server needs to be restarted for the changes to take effect. Additionally you need to setup a PostgreSQL user with the same username as the local user and give it trust or ident in your hba file. Or you can export $PGUSER and $PGPASSWORD before running tests.Testing hstore on 9.0PostgreSQL versions 9.0 does not have the CREATE EXTENSION commands. This means we have to locate the postgres installation and run the hstore.sql in contrib to install hstore. Below is an example command to test 9.0 on OS X with homebrew installed postgres:$ PGVERSION=9.0 PGPATH=/usr/local/share/postgresql9/ mix test","ref":"readme.html#contributing","title":"Postgrex - Contributing","type":"extras"},{"doc":"Copyright 2013 Eric Meadows-JönssonLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License athttp://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Postgrex - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Bug fixesMake sure scram authentication method works on Erlang/OTP 24","ref":"changelog.html#v0-15-8-2021-01-19","title":"Changelog - v0.15.8 (2021-01-19)","type":"extras"},{"doc":"EnhancementsAdd compare and to_string to Postgrex.IntervalBug fixesAllow deallocated queries to be re-prepared","ref":"changelog.html#v0-15-7-2020-10-17","title":"Changelog - v0.15.7 (2020-10-17)","type":"extras"},{"doc":"EnhancementsSupport Decimal 2.0Bug fixesDo not keep credentials in state in Postgrex.Notifications","ref":"changelog.html#v0-15-6-2020-09-21","title":"Changelog - v0.15.6 (2020-09-21)","type":"extras"},{"doc":"EnhancementsSupport optional decoding of infinite timestampsBug fixesRemove cache statements that cannot be described from cache when on a savepoint transaction (such as when inside the SQL sandbox)","ref":"changelog.html#v0-15-5-2020-06-03","title":"Changelog - v0.15.5 (2020-06-03)","type":"extras"},{"doc":"EnhancementsFix warnings on Elixir v1.11.0-dev","ref":"changelog.html#v0-15-4-2020-05-09","title":"Changelog - v0.15.4 (2020-05-09)","type":"extras"},{"doc":"EnhancementsAllow dynamic connection configuration with the :configure for notificationsAdd :auto_reconnect option for notificationsAccept listen commands even if the notifications connection is down or yet to first connectBug fixesEncode empty arrays in a mechanism compatible with CockroachDBCleanly terminate connection started with a socket","ref":"changelog.html#v0-15-3-2019-12-11","title":"Changelog - v0.15.3 (2019-12-11)","type":"extras"},{"doc":"EnhancementsImprove performance of the bootstrap query","ref":"changelog.html#v0-15-2-2019-10-08","title":"Changelog - v0.15.2 (2019-10-08)","type":"extras"},{"doc":"EnhancementsAdd support for microseconds in Postgrex.IntervalReduce bootstrap log message to debug and clarify error message","ref":"changelog.html#v0-15-1-2019-09-16","title":"Changelog - v0.15.1 (2019-09-16)","type":"extras"},{"doc":"Postgrex v0.15+ requires Elixir v1.6+.EnhancementsFilter bootstrap more efficiently by avoiding loading tables information on startupOnly bootstrap new oids during describe: this means reconnects don't run a bootstrap query and describe runs minimal queryParse Postgrex 12beta new version formatRaise error when :ssl is required and not started in child_spec/1Bug fixesDon't encode DateTime, NaiveDateTime or Time unless Calendar.ISO","ref":"changelog.html#v0-15-0-2019-07-18","title":"Changelog - v0.15.0 (2019-07-18)","type":"extras"},{"doc":"EnhancementsMake bootstrap query compatible with CockroachDB 19.1Improve error message when encoding bad tuple","ref":"changelog.html#v0-14-3-2019-05-08","title":"Changelog - v0.14.3 (2019-05-08)","type":"extras"},{"doc":"Bug fixesFix Elixir deprecation warningsDo not crash when receiving notices during authenticationDo not crash when receiving an error (caused by a raise) during query execution","ref":"changelog.html#v0-14-2-2019-04-12","title":"Changelog - v0.14.2 (2019-04-12)","type":"extras"},{"doc":"Bug fixesBump decimal dependency to avoid runtime warnings","ref":"changelog.html#v0-14-1-2018-11-24","title":"Changelog - v0.14.1 (2018-11-24)","type":"extras"},{"doc":"EnhancementsPostgrex.INET will add a /32 netmask to an IPv4 address and a /128 netmask to an IPv6 address during encoding where netmask: nil. When decoding, a /32 netmask (for IPv4) or /128 netmask (for IPv6) will be removed, resulting in netmask: nil for the structAdd :disconnect_on_error_codes which allows Postgrex to automatically disconnect and then reconnect on certain errors. This is useful when using Postgrex against systems that support failover, which would emit certain errors on failover. This change allow those errors to be recovered from transparentlyAdd :cache_statement to Postgrex.query/4 as a built-in statement cacheSupport scram-sha-256 authentication from PostgreSQL 10Add Postgrex.prepare_execute/4Automatically re-prepare queries that failed to encode due to a database type changeBackwards incompatible changesInvoke encode_to_iodata! instead of encode! in JSON encoderRemove Postgrex.CIDR and use Postgrex.INET to encode both inet/cidr (as PostgreSQL may perform implicit/explicit casting at any time)Postgrex.Time, Postgrex.Date and Postgrex.Timestamp were deprecated and now have been effectively removedPostgrex.execute/4 now always returns the prepared query:pool_timeout is removed in favor of :queue_target and :queue_interval. See DBConnection.start_link/2 for more information","ref":"changelog.html#v0-14-0-2018-10-29","title":"Changelog - v0.14.0 (2018-10-29)","type":"extras"},{"doc":"EnhancementsSupport custom range domainsSupport custom array domainsAdd support for UNIX domain sockets via the :socket_dir optionRemove warnings on Elixir v1.6Bug fixesFix encoding of empty rangesFix Postgrex.Path open/closed byte parity","ref":"changelog.html#v0-13-4-2018-01-25","title":"Changelog - v0.13.4 (2018-01-25)","type":"extras"},{"doc":"EnhancementsReload types on unknown oid during prepareBug fixesFix default timeout for connection process from 5000s to 15000s","ref":"changelog.html#v0-13-3-2017-05-31","title":"Changelog - v0.13.3 (2017-05-31)","type":"extras"},{"doc":"Bug fixesDo not build invalid dates at compilation time on Elixir master","ref":"changelog.html#v0-13-2-2017-03-05","title":"Changelog - v0.13.2 (2017-03-05)","type":"extras"},{"doc":"EnhancementsAllow naming Postgrex.Notifications serverProvide tsvector and lexeme support using binary formatsBug fixesFix encoding of Decimal values that would be wrong in certain circumstancesAdd :crypto to applicationsSpecify proper Elixir dependencyRestore compatibility with postgres versions prior to 8.4 and with redshift","ref":"changelog.html#v0-13-1-2017-02-20","title":"Changelog - v0.13.1 (2017-02-20)","type":"extras"},{"doc":"EnhancementsSupport built-in geometry typesFallback to PGDATABASE system env for the databaseSupport bit and varbit typesAdd postgres error code to error messagesSupport unprepared when using a stream:connect_timeout and :handshake_timeout to configure TCP connect and handshake timeoutsImprove numeric encode/decodeBug fixesQuote channel on listen/unlistenCheck datetime structs available before defining calendar extensionBackoff all awaiting connections if a bootstrap fails to prevent timeout loopHandle idle admin shutdown of postgres backendFix rebootstrap query to be O(Nlog(N)) instead of O(N^2)Fix encoding of numerical valuesBackwards incompatible changes:copy_data query option is no longer supported and data can only be copied to the database using a collectableQuery struct has removed encoders/decoders and changed param_info/result_info valuesExtensions now use a new encoder/decoder API based on quoted expressionsThe :extensions, :decode_binary and :null options in start_link are no longer supported in favor of defining custom types with Postgrex.Types.define(module, extra_extensions, options). Postgrex.Types.define/3 must be called on its own file, outside of any module and function, as it only needs to be defined once during compilation.","ref":"changelog.html#v0-13-0-2016-12-17","title":"Changelog - v0.13.0 (2016-12-17)","type":"extras"},{"doc":"EnhancementsSupport special &quot;char&quot; typeBug fixesLimit re-bootstrap to one connection at a timeFix re-bootstrap of new composite types that use old types","ref":"changelog.html#v0-12-1-2016-09-29","title":"Changelog - v0.12.1 (2016-09-29)","type":"extras"},{"doc":"EnhancementsRaise DBConnection.ConnectionError on connection errorUse send encoding to determine citext encodingUse Map in favor of deprecated modules (to avoid warnings on v1.4)Run rebootstrap test synchronously on every connectAdd support for Elixir 1.3+ Calendar types","ref":"changelog.html#v0-12-0-2016-09-06","title":"Changelog - v0.12.0 (2016-09-06)","type":"extras"},{"doc":"EnhancementsAdd support for COPY TO STDOUT and COPY FROM STDINSupport packets bigger than 64MBIntroduce mode: :savepoint for prepare/execute/close that allows wrapping a request in a savepoint so that an error does not fail the transactionIntroduce streaming queriesAdd :decode_binary option which is either :copy (default) or :reference.Bug fixesConsistently convert the port number to integerRemove type server entry on disconnect","ref":"changelog.html#v0-11-2-2016-06-16","title":"Changelog - v0.11.2 (2016-06-16)","type":"extras"},{"doc":"EnhancementsSupport PgBouncer transaction/statement poolingInclude more information in error messagesAdd support for built-in postgres point typeAdd Postgrex.child_spec/1Allow custom encoding/decoding of postgres' NULL on a per query basisBug fixesCorrectly pad decimal digits during encoding","ref":"changelog.html#v0-11-1-2016-02-15","title":"Changelog - v0.11.1 (2016-02-15)","type":"extras"},{"doc":"EnhancementsRely on DBConnection. This means better performance by copying less data between processes, faster encoding/decoding, support for transactions, after_connect hooks, connection backoff, logging, prepared queries, the ability to use both Poolboy and Sojourn as pools out of the box, and moreBackwards incompatible changeConnection API from Postgrex.Connection has been moved to PostgrexNotifications API from Postgrex.Connection has been moved to Postgrex.Notifications","ref":"changelog.html#v0-11-0-2016-01-21","title":"Changelog - v0.11.0 (2016-01-21)","type":"extras"},{"doc":"EnhancementsImprove error message on encoding/decoding failuresAdd network types such as: inet, cidr and macaddrImprove TCP error messagesSupport PGPORT environment variableImprove decoding performance by caching extension informationImprove query performance by decoding in the client process hence not blocking the connectionRaise if number of parameters to query is wrongBug fixesCorrectly handle errors in connection initialization with sync_connect: trueDo not fail on custom error codesCorrectly handle large number of parameters, also fixes some protocol issues where unsigned integers were treated as signed","ref":"changelog.html#v0-10-0-2015-11-17","title":"Changelog - v0.10.0 (2015-11-17)","type":"extras"},{"doc":"EnhancementsRevert client side decoding as affects performance negatively (around 15% slower)Cast floats and integers to decimal if a decimal is requested","ref":"changelog.html#v0-9-1-2015-07-14","title":"Changelog - v0.9.1 (2015-07-14)","type":"extras"},{"doc":"EnhancementsCached type bootstrapping for less memory usage and faster connection set upThe result set is now decoded in the calling process to reduce time spent in the connection processAdd a decode: :manual option to Postgrex.query/4 and the function Postgrex.decode/2 for manually decoding the resultAdd :sync_connect option to Postgrex.start_link/1Bug fixesCorrectly handle extension types created inside schemasBackwards incompatible changesEach row in Postgrex.Result.rows is now a list of columns instead of a tuple","ref":"changelog.html#v0-9-0-2015-07-12","title":"Changelog - v0.9.0 (2015-07-12)","type":"extras"},{"doc":"Bug fixesFix version detection","ref":"changelog.html#v0-8-4-2015-06-24","title":"Changelog - v0.8.4 (2015-06-24)","type":"extras"},{"doc":"EnhancementsAdd Postgrex.Extensions.JSON extension for json and jsonb typesSet suitable TCP buffer size automatically","ref":"changelog.html#v0-8-3-2015-06-22","title":"Changelog - v0.8.3 (2015-06-22)","type":"extras"},{"doc":"EnhancementsAdd :socket_options option to Postgrex.start_link/1Improved performance regarding binary handlingAdd hstore supportBackwards incompatible changesRemove :async_connect option and make it the default","ref":"changelog.html#v0-8-2-2015-06-01","title":"Changelog - v0.8.2 (2015-06-01)","type":"extras"},{"doc":"EnhancementsKeep the postgres error code in :pg_codeSupport oid types and all its aliases (regclass etc)Backwards incompatible changesRename :msec field to :usec on Postgrex.Time and Postgrex.TimestampBug fixesFix numeric encoding for fractional numbers with less digits than the numeric baseSupport encoding timetz typeFix time and timestamp off-by-one bounds","ref":"changelog.html#v0-8-1-2015-04-09","title":"Changelog - v0.8.1 (2015-04-09)","type":"extras"},{"doc":"EnhancementsAdd extensionsEncode/decode ranges genericallyAdd bounds when encoding integer types to error instead of overflowing the integerLog unhandled PostgreSQL errors (when it cant be replied to anyone)Add support for enum typesAdd support for citext typeAdd microseconds to times and timestampsAdd the ability to rebootstrap types for an open connectionBackwards incompatible changesRemove the support for type-hinted queriesRemove encoder, decoder and formatter functions, use extensions insteadUse structs for dates, times, timestamps, interval and rangesChange the default timeout for all operations to 5000msShow PostgreSQL error codes as their names instead","ref":"changelog.html#v0-8-0-2015-02-26","title":"Changelog - v0.8.0 (2015-02-26)","type":"extras"},{"doc":"EnhancementsAdd asynchronous notifications through listen and unlistenAdd support for range typesAdd support for uuid typeAdd :async_connect option to start_link/1Bug fixesFix encoding nil values in arrays and composite types","ref":"changelog.html#v0-7-0-2015-01-20","title":"Changelog - v0.7.0 (2015-01-20)","type":"extras"},{"doc":"EnhancementsQueries can be constructed of iodataSupport &quot;type hinted&quot; queries to save one client-server round trip which will reduce query latencyBackwards incompatible changesPostgrex.Error postgres field is converted from keyword list to mapPostgrex.Connect.query params parameter is no longer optional (pass an empty list if query has no parameters)The timeout parameter for all functions have been moved to a keyword list with the key :timeout","ref":"changelog.html#v0-6-0-2014-09-07","title":"Changelog - v0.6.0 (2014-09-07)","type":"extras"},{"doc":"EnhancementsReduce the amount of intermediary binaries constructed with the help of iodata","ref":"changelog.html#v0-5-5-2014-08-20","title":"Changelog - v0.5.5 (2014-08-20)","type":"extras"},{"doc":"","ref":"changelog.html#v0-5-4-2014-08-04","title":"Changelog - v0.5.4 (2014-08-04)","type":"extras"},{"doc":"","ref":"changelog.html#v0-5-3-2014-07-13","title":"Changelog - v0.5.3 (2014-07-13)","type":"extras"},{"doc":"","ref":"changelog.html#v0-5-2-2014-06-18","title":"Changelog - v0.5.2 (2014-06-18)","type":"extras"},{"doc":"Backwards incompatible changesPostgrex.Error exception converted to struct","ref":"changelog.html#v0-5-1-2014-05-24","title":"Changelog - v0.5.1 (2014-05-24)","type":"extras"},{"doc":"Backwards incompatible changesPostgrex.Result and Postgrex.TypeInfo converted to structs","ref":"changelog.html#v0-5-0-2014-05-01","title":"Changelog - v0.5.0 (2014-05-01)","type":"extras"},{"doc":"EnhancementsAdd timeouts to all synchronous calls. When a timeout is hit an exit error will be raised in the caller process and the connection process will exitAdd automatic fallback to environment variables PGUSER, PGHOST and PGPASSWORD","ref":"changelog.html#v0-4-2-2014-04-21","title":"Changelog - v0.4.2 (2014-04-21)","type":"extras"},{"doc":"EnhancementsNumerics decode and encode to Decimal","ref":"changelog.html#v0-4-0-2014-01-16","title":"Changelog - v0.4.0 (2014-01-16)","type":"extras"},{"doc":"EnhancementsCompact state before printing to logs and hide passwordConcurrency support, safe to use connection from multiple processes concurrently","ref":"changelog.html#v0-3-1-2014-01-15","title":"Changelog - v0.3.1 (2014-01-15)","type":"extras"},{"doc":"Bug fixesDon't try to decode values of text formatBackwards incompatible changesTypes are stored as binaries instead of atoms, update your custom encoders and decoders","ref":"changelog.html#v0-3-0-2013-12-16","title":"Changelog - v0.3.0 (2013-12-16)","type":"extras"},{"doc":"EnhancementsAdd support for SSLBug fixesFix decoding of unknown type when using custom decoder","ref":"changelog.html#v0-2-1-2013-12-10","title":"Changelog - v0.2.1 (2013-12-10)","type":"extras"},{"doc":"EnhancementsFloats handles NaN, inf and -infAdd support for numericsCustom encoders and decoders works on elements in arraysAdd support for composite typesAdd functions that raise on errorBug fixesINSERT query works with extended query parametersReturn proper num_rows on PostgreSQL 8.4Fix race conditionBackwards incompatible changesSimplify custom decoding and encoding with default function","ref":"changelog.html#v0-2-0-2013-11-14","title":"Changelog - v0.2.0 (2013-11-14)","type":"extras"},{"doc":"First release!","ref":"changelog.html#v0-1-0-2013-10-14","title":"Changelog - v0.1.0 (2013-10-14)","type":"extras"}]